/*
 * Copyright (c) 2015, Matias Fontanini
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 * * Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer.
 * * Redistributions in binary form must reproduce the above
 *   copyright notice, this list of conditions and the following disclaimer
 *   in the documentation and/or other materials provided with the
 *   distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

#include <iostream>
#include <iomanip>
#include <vector>
#include <tins/tins.h>

using std::cout;
using std::endl;
using std::setw;
using std::vector;

using namespace Tins;

int main() {
    vector<Utils::RouteEntry> v4_entries = Utils::route_entries();
    cout << "IPv4 route table entries: " << endl
         << "========================= " << endl;
    for (size_t i = 0; i < v4_entries.size(); ++i) {
        cout << "Entry " << setw(2) << i << ": " << endl
             << "Interface:   " << v4_entries[i].interface << endl
             << "Destination: " << v4_entries[i].destination << endl
             << "Gateway:     " << v4_entries[i].gateway << endl
             << "Genmask:     " << v4_entries[i].mask << endl
             << "Metric:      " << v4_entries[i].metric << endl << endl;
    }

    vector<Utils::Route6Entry> v6_entries = Utils::route6_entries();
    if (!v6_entries.empty()) {
        cout << endl
             << "IPv6 route table entries: " << endl
             << "========================= " << endl;
        for (size_t i = 0; i < v6_entries.size(); ++i) {
            cout << "Entry " << setw(2) << i << ": " << endl
                 << "Interface:   " << v6_entries[i].interface << endl
                 << "Destination: " << v6_entries[i].destination << endl
                 << "Gateway:     " << v6_entries[i].gateway << endl
                 << "Genmask:     " << v6_entries[i].mask << endl
                 << "Metric:      " << v6_entries[i].metric << endl << endl;
        }
    }
}